/**
 *  psd.ivp
 */
#include "stdafx.h"
#include "rle.hxx"

void UnpackBits(IByteReader *reader, IByteWriter *writer)
{
	for (;;) {
		BYTE n;
		if (!reader->Get(n))
			return;
		if (n & 0x80) {
			n = static_cast<BYTE>(0x101 - n);
			BYTE x;
			if (!reader->Get(x))
				return;
			while (n--)
				writer->Put(x);
		} else {
			n = 1 + n;
			while (n--) {
				BYTE x;
				if (!reader->Get(x))
					return;
				writer->Put(x);
			}
		}
	}
}
